SUBROUTINE ADCALCULATE_OPTICAL_PROPERTIES &
           (NLAY, NCOMP, ML, SPECIESFLAG, LWP, ADLWP, RMM, ADRMM, &
           MOLECTAU, ADMOLECTAU, TAURAYL, ADTAURAYL, SRCTYPE, SOLARMU, &
           NOUT, MUOUT, PHIOUT, TAUP, ADTAUP, ALBEDOP, ADALBEDOP, &
           LEGENP, ADLEGENP, SSPHASE, ADSSPHASE, NSCATTAB, SPECIES2TABLE, &
           MAXNR, NRTAB, RTAB, EXTINCTTAB, SSALBTAB, MAXLEG, NLEGTAB, LEGENTAB)
  IMPLICIT NONE
  INTEGER :: NLAY, NCOMP, ML,  NOUT,  NSCATTAB, SPECIES2TABLE(NCOMP)
  INTEGER :: MAXNR, NRTAB(NSCATTAB), MAXLEG, NLEGTAB(MAXNR,NSCATTAB)
  LOGICAL :: SPECIESFLAG(NCOMP,NLAY)
  REAL    :: LWP(NCOMP,NLAY), ADLWP(NCOMP,NLAY), RMM(NCOMP,NLAY), ADRMM(NCOMP,NLAY)
  REAL    :: MOLECTAU(NLAY), ADMOLECTAU(NLAY), TAURAYL(NLAY), ADTAURAYL(NLAY)
  REAL    :: SOLARMU, MUOUT(NOUT), PHIOUT(NOUT), TAUP(NLAY), ADTAUP(NLAY)
  REAL    :: ALBEDOP(NLAY), ADALBEDOP(NLAY), LEGENP(1:ML+1,NLAY), ADLEGENP(1:ML+1,NLAY)
  REAL    :: SSPHASE(NLAY,NOUT), ADSSPHASE(NLAY,NOUT)
  REAL    :: RTAB(MAXNR,NSCATTAB), EXTINCTTAB(MAXNR,NSCATTAB)
  REAL    :: SSALBTAB(MAXNR,NSCATTAB), LEGENTAB(1:MAXLEG,MAXNR,NSCATTAB)
  CHARACTER*(1) :: SRCTYPE

  PRINT *, 'SHDOMPPDA adjoint is unavailable'
  STOP
END SUBROUTINE ADCALCULATE_OPTICAL_PROPERTIES



SUBROUTINE ADSOLVE_FIXED_SHDOMPP2 &
           (NLAY, TEMPP, ADTEMPP, TAUP, ADTAUP, ALBEDOP, ADALBEDOP, &
            LEGENP, ADLEGENP, SSPHASE, ADSSPHASE, &
            NPTS, FRACTAUG, IXP, SHSOURCE, &
            ML, MM, NLM, NMU, NPHI, NPHI0MAX, SRCTYPE, SOLARFLUX, SOLARMU, &
            WAVELEN, WAVENO, SKYRAD, SFCTEMP, ADSFCTEMP, SFCTYPE, SFCPARMS, &
            ADSFCPARMS, NMOREITER, ACCELPAR, NOUT, MUOUT, PHIOUT, ADRADOUT)
  IMPLICIT NONE
  INTEGER :: NLAY, NPTS, IXP(2,NLAY)
  INTEGER :: ML, MM, NLM, NMU, NPHI, NPHI0MAX, NMOREITER, NOUT
  REAL    :: TEMPP(NLAY+1), ADTEMPP(NLAY+1), TAUP(NLAY), ADTAUP(NLAY)
  REAL    :: ALBEDOP(NLAY), ADALBEDOP(NLAY),  LEGENP(1:ML+1,NLAY), ADLEGENP(1:ML+1,NLAY)
  REAL    :: SSPHASE(NLAY,NOUT), ADSSPHASE(NLAY,NOUT)
  REAL    :: FRACTAUG(NPTS), SHSOURCE(NLM,NPTS), SOLARFLUX, SOLARMU
  REAL    :: WAVELEN, WAVENO(2), SKYRAD, SFCTEMP, ADSFCTEMP
  REAL    :: SFCPARMS(*), ADSFCPARMS(*), ACCELPAR(NMOREITER)
  REAL    :: MUOUT(NOUT), PHIOUT(NOUT), ADRADOUT(NOUT)
  CHARACTER(1) :: SRCTYPE, SFCTYPE

  PRINT *, 'SHDOMPPDA adjoint is unavailable'
  STOP
END SUBROUTINE ADSOLVE_FIXED_SHDOMPP2
